unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,Math,
  Dialogs, StdCtrls, ExtCtrls, Grids, ComCtrls;

type
  TForm4 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Shape1: TShape;
    Shape2: TShape;
    Edit9: TEdit;
    Edit10: TEdit;
    Button3: TButton;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    RadioGroup4: TRadioGroup;
    Label3: TLabel;
    Shape3: TShape;
    Shape4: TShape;
    Image1: TImage;
    Image2: TImage;
    StringGrid1: TStringGrid;
    RadioGroup5: TRadioGroup;
    Label4: TLabel;
    TrackBar1: TTrackBar;
    Label5: TLabel;
    Button4: TButton;
    Edit11: TEdit;
    Label6: TLabel;
    RadioGroup6: TRadioGroup;
    Memo1: TMemo;
    Label7: TLabel;
    Edit12: TEdit;
    Edit13: TEdit;
    Label8: TLabel;
    Edit14: TEdit;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup4Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Edit11Change(Sender: TObject);
    procedure RadioGroup6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.Button1Click(Sender: TObject);
var testgrad,testkwert,testfokus,testlaenge,energy,c,m0 : real;
begin
  testlaenge := strtofloat(form4.Edit2.text)/1000;
  energy     := strtofloat(form4.edit1.text);
  m0 := 0.510998910; //Ruheenergie electron
  c  := 2.99792458E+8;           //Lichtgeschwindigkeit
if testlaenge > 0 then
begin
//Gradient -> Kwert,...
//if form4.RadioButton1.Checked = true then
if form4.RadioGroup1.ItemIndex = 0 then
begin
  testgrad  := strtofloat(form4.Edit3.Text);
  testkwert := c*testgrad/( Sqrt(energy*energy - m0*m0) *1E+6);
  testfokus := 1/(testkwert * testlaenge);

  form4.Edit4.Text :=floattostr(testkwert);
  form4.Edit5.text :=floattostr(testfokus*1000);
end;
//if form4.RadioButton2.Checked = true then
if form4.RadioGroup1.ItemIndex = 1 then
begin
  testkwert := strtofloat(form4.Edit4.text);
  testgrad  := testkwert* (Sqrt(energy*energy - m0*m0)/c)*1E+6;
  testfokus := 1/(testkwert * testlaenge);

  form4.Edit3.Text :=floattostr(testgrad);
  form4.Edit5.text :=floattostr(1000*testfokus);
end;
//if form4.RadioButton3.Checked = true then
if form4.RadioGroup1.ItemIndex = 2 then
begin
  testfokus := strtofloat(form4.Edit5.text)/1000;
  testkwert := 1/(testlaenge * testfokus);
  testgrad  := testkwert* (Sqrt(energy*energy - m0*m0)/c)*1E+6;

  form4.Edit3.Text :=floattostr(testgrad);
  form4.Edit4.text :=floattostr(testkwert);
end;
end;   //Ende Lnge > 0 !!
end;   //Ende Procedure QP_Berechnung
procedure TForm4.Button2Click(Sender: TObject);
begin
  form4.Visible:=false;
end;
procedure TForm4.Button3Click(Sender: TObject);
Var tenergy,tf,tr,tl,tw,ts,c,m0 :real;
begin
tenergy := strtofloat(form4.Edit1.text);
c       := 2.99792458E+8;           //Lichtgeschwindigkeit
m0      := 0.510998910;             //Ruheenergie electron

if form4.RadioGroup2.ItemIndex = 0 then  //BEGINN FELD
begin
// form4.Caption:='IDDQD';
tF := strtofloat(form4.Edit6.text)/1000;
tr := Sqrt(tenergy*tenergy - m0*m0)*1E+6/(c*tf);
form4.Edit7.Text:=floattostr(tr);


end; //Ende Feld
if form4.RadioGroup2.ItemIndex = 1 then  //BEGINN Radius
begin
// form4.Caption:='IDKFA';
tr := strtofloat(form4.Edit7.text);
tf := Sqrt(tenergy*tenergy - m0*m0)*1E+6/(c*tr);
form4.Edit6.Text:=floattostr(tf*1000);
end; //Ende Radius


if (tr=0)or(tf=0) then exit;

//Vorraussetzung fr nchste Rechnungen (Radius)

if form4.RadioGroup4.ItemIndex = 0 then  //BEGINN Bild1
begin
if form4.RadioGroup3.ItemIndex = 0 then  //BEGINN phy. Lnge
begin
// form4.Caption:='IDKFA';
tl := strtofloat(form4.Edit8.text)/1000;
if (tl/tr < 1) then
 begin
 tw := ArcSin(tl/tr);
 form4.Edit9.Text:=floattostr(tw);
form4.Edit10.Text:=floattostr(tr*tw*1000);
 end else
 begin
//  form4.Edit9.Text:='error';
if  form4.Caption = 'translate'  then  Showmessage('inc. mag. length') else  Showmessage('mag. Lnge zu klein');
 end;
end; //Ende phy.Lnge

if form4.RadioGroup3.ItemIndex = 1 then  //BEGINN Winkel
begin
// form4.Caption:='IDKFA';
tw := strtofloat(form4.Edit9.text);
 tl := tr*Sin(tw);
 form4.Edit8.Text:=floattostr(tl*1000);
form4.Edit10.Text:=floattostr(tr*tw*1000);
end; //Ende Winkel

end;//ENDE BILD 1

if form4.RadioGroup4.ItemIndex = 1 then  //BEGINN Bild2
begin
if form4.RadioGroup3.ItemIndex = 0 then  //BEGINN phy. Lnge
begin
// form4.Caption:='IDKFA';
tl := strtofloat(form4.Edit8.text)/1000;
if ((tl/(tr*2)) < 1) then
 begin
 tw := 2*ArcSin(tl/(2*tr));
 form4.Edit9.Text:=floattostr(tw);
form4.Edit10.Text:=floattostr(tr*tw*1000);
 end else
 begin
//  form4.Edit9.Text:='error';
if  form4.Caption = 'translate'  then  Showmessage('inc. mag. length') else  Showmessage('mag. Lnge zu klein');
 end;
end; //Ende phy.Lnge

if form4.RadioGroup3.ItemIndex = 1 then  //BEGINN Winkel
begin
// form4.Caption:='IDKFA';
tw := strtofloat(form4.Edit9.text);
 tl := 2*tr*Sin(tw/2);
 form4.Edit8.Text:=floattostr(tl*1000);
form4.Edit10.Text:=floattostr(tr*tw*1000);
end; //Ende Winkel
end;//ENDE BILD 2


end;
procedure TForm4.Button4Click(Sender: TObject);
var tenergy,Ekin,E0,sigz,DE : real;
    freq, well, c, tgamma : real;
    sig_grad,dpp,egrad,erad : real;
    gbeta,rbeta,rbetan :real;
begin
 c       := 2.99792458E+8;

 tenergy := strtofloat(form4.Edit1.text)*1E+6;
 E0      := strtofloat(form4.Edit11.text)*1E+6;
 freq    := strtofloat(form4.Edit12.text)*1E+6;
 sigz    := strtofloat(form4.Edit13.text)*1E-3;
 DE      := strtofloat(form4.Edit14.text)*1E+3;

 tgamma  := tenergy/E0;
 Ekin    := Sqrt((sqr(tenergy) - sqr(E0)));
 well    := c/freq;

 dpp    := ((tgamma/(tgamma+1))/Ekin)*DE;
 rbeta  := sigz*dpp;
 rbetan := rbeta*tgamma;
 sig_grad:= sigz*360/(well*sqrt(1-(sqr(1/tgamma))));
 egrad := (1);
form4.Memo1.Lines.Add(floattostr( sqrt(1-(sqr(1/tgamma)))));
form4.Memo1.Lines.Add(floattostr( rbetan*1E-6));

end;
procedure TForm4.Edit11Change(Sender: TObject);
begin

form4.RadioGroup6.ItemIndex:=2;

end;
procedure TForm4.FormCreate(Sender: TObject);
var vz : string;
begin
  vz := ExtractFilePath(Application.ExeName);
form4.Image1.Stretch :=true;
form4.Image2.Stretch :=true;
if FileExists(vz+'bmp\Sbend_Laenge1.bmp') then form4.Image1.Picture.LoadFromFile(vz+'bmp\Sbend_Laenge1.bmp');
if FileExists(vz+'bmp\Sbend_Laenge2.bmp') then form4.Image2.Picture.LoadFromFile(vz+'bmp\Sbend_Laenge2.bmp');

end;
procedure TForm4.Image1Click(Sender: TObject);
begin
form4.Shape4.Pen.Style:= psClear;
form4.Shape3.Pen.Style:= psSolid;
form4.RadioGroup4.ItemIndex:=0;

end;
procedure TForm4.Image2Click(Sender: TObject);
begin
form4.Shape4.Pen.Style:= psSolid;
form4.Shape3.Pen.Style:= psClear;
form4.RadioGroup4.ItemIndex:=1;
end;
procedure TForm4.RadioGroup4Click(Sender: TObject);
begin
if form4.RadioGroup4.ItemIndex = 0 then  //BEGINN Standard gewhlt
begin
form4.Shape3.Pen.Style:= psSolid;
form4.Shape4.Pen.Style:= psClear;
end;
if form4.RadioGroup4.ItemIndex = 1 then  //BEGINN Standard gewhlt
begin
form4.Shape4.Pen.Style:= psSolid;
form4.Shape3.Pen.Style:= psClear;
end;

end;
procedure TForm4.RadioGroup6Click(Sender: TObject);
begin

if form4.RadioGroup6.ItemIndex = 0 then  form4.Edit11.text:='0,510998918';
if form4.RadioGroup6.ItemIndex = 1 then  form4.Edit11.text:='938,272029';

if form4.Edit11.text='0,510998918'  then form4.RadioGroup6.ItemIndex := 0;
if form4.Edit11.text='938,272029'  then form4.RadioGroup6.ItemIndex := 1;


end;
end.
